$regfile = "attiny2313.dat"
$crystal = 12000000                               ' external crystal
$hwstack = 48
$swstack = 8
$framesize = 24
$prog &HFF , &HFF , &H9F , &H00                   ' fuse bytes

Dim Bpressedkey As Byte , Bkey As Byte
Dim Bminutes As Byte , Bseconds As Byte
Dim Stime As String * 4 , Sminutes As String * 2 , Sseconds As String * 2
Dim S As String * 2

Config Portd = Output                             ' port for LCD en opto-triac

Config Lcdpin = Pin , Db4 = Portd.2 , Db5 = Portd.3 , Db6 = Portd.4 , Db7 = Portd.5 , E = Portd.1 , Rs = Portd.0
Config Lcd = 16 * 2
Deflcdchar 0 , 32 , 14 , 21 , 23 , 17 , 14 , 32 , 32       ' define clock symbol
Deflcdchar 1 , 4 , 14 , 10 , 10 , 10 , 14 , 4 , 32       ' define load symbol
Cursor Off

Config Kbd = Portb , Debounce = 40 , Delay = 25   ' config keypad

Config Timer1 = Timer , Prescale = 256 , Compare A = Disconnect , Clear Timer = 1
Compare1a = 46875                                 ' generate interrupt and clear timer at 46875
Enable Interrupts                                 ' causing a 1Hz interrupt
Enable Compare1a
On Compare1a Tim1_isr
Stop Timer1

'***********************************************************'

Cls
Lcd "initializing..."
Waitms 500
Cls

Stime = "0000"                                    ' set the timestring to 0

Locate 1 , 5 : Lcd Chr(0) ; " 00:00"              ' display the time
Locate 2 , 5 : Lcd Chr(1) ; " OFF"                ' and the status

'***********************************************************'

Subinput:
Bpressedkey = Getkbd()                            ' scan keyboard
If Bpressedkey = 3 Then Goto Substart             ' start was pressed *
If Bpressedkey = 1 Then Goto Subreset             ' reset was pressed *
If Bpressedkey <> 16 Then Goto Subkey             ' another key was pressed
Goto Subinput

'***********************************************************'

Subkey:
Bkey = Lookup(bpressedkey , Keypad)               ' find which key is pressed

Stime = Right(stime , 3)                          ' add it to the timestring
Stime = Stime + Str(bkey)

Sminutes = Left(stime , 2)                        ' extract minutes and seconds
Sseconds = Right(stime , 2)                       ' from the new string

Bminutes = Val(sminutes)                          ' and convert both into values
Bseconds = Val(sseconds)

Locate 1 , 7 : Lcd Sminutes ; ":" ; Sseconds      ' refresh time
Do : Loop Until Bpressedkey <> Getkbd()           ' loop untill key is released
Goto Subinput                                     ' back to main

'***********************************************************'

Substart:
If Stime = "0000" Then Goto Subinput              ' if time is still zero, go back to inputloop

Start Timer1                                      ' start the countdown interrupt

Portd.6 = 1                                       ' turn on the load
Locate 2 , 7 : Lcd "ON "                          ' and refresh status on LCD

Do                                                ' loop while coundown is active
If Getkbd() = 1 Then                              ' if stop is pressed *
  Do : Loop Until Getkbd() <> 1                   ' loop until it's released *
  Goto Substop                                    ' and goto stop routine
End If
Loop Until Stime = "0000"

Substop:                                          ' stop routine
Stop Timer1                                       ' stop the countdown interrupt
Portd.6 = 0                                       ' turn off the load
Locate 2 , 7 : Lcd "OFF"                          ' and refresh status on LCD
Goto Subinput                                     ' back to main

'***********************************************************'

Subreset:
Bminutes = 0                                      ' set everything to zero
Bseconds = 0
Stime = "0000"
Timer1 = 0                                        ' reset the timer

Locate 1 , 7 : Lcd "00:00"                        ' and refresh time on LCD

Do : Loop Until Bpressedkey <> Getkbd()           ' loop until reset is released
Goto Subinput                                     ' back to main

'***********************************************************'

Tim1_isr:                                         ' timer interrupt
If Bseconds = 0 Then
  If Bminutes <> 0 Then
    Decr Bminutes                                 ' turn 1:00 into 0:60
    Bseconds = 60
  End If
End If
Decr Bseconds                                     ' substract a second

S = Str(bseconds)                                 ' convert values to strings
Sseconds = Format(s , "00")                       ' and add 0 when needed
S = Str(bminutes)
Sminutes = Format(s , "00")
Stime = Sminutes + Sseconds                       ' make the timestring

Locate 1 , 7 : Lcd Sminutes ; ":" ; Sseconds      ' and refresh time on LCD
Return

'***********************************************************'

Keypad:                                           ' lookup table for keypad *
  Data 0 , 0 , 0 , 0 , 0 , 9 , 8 , 7 , 0 , 6 , 5 , 4 , 0 , 3 , 2 , 1

' *) Values will have to be changed if the keypad is connected in another way